<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfValidationDetail ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfValidationDetail
 * @subpackage Arrays
 */
class ArrayOfValidationDetail extends AbstractStructArrayBase
{
    /**
     * The ValidationDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ValidationDetail[]
     */
    public $ValidationDetail;
    /**
     * Constructor method for ArrayOfValidationDetail
     * @uses ArrayOfValidationDetail::setValidationDetail()
     * @param \StructType\ValidationDetail[] $validationDetail
     */
    public function __construct(array $validationDetail = array())
    {
        $this
            ->setValidationDetail($validationDetail);
    }
    /**
     * Get ValidationDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ValidationDetail[]|null
     */
    public function getValidationDetail()
    {
        return isset($this->ValidationDetail) ? $this->ValidationDetail : null;
    }
    /**
     * Set ValidationDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ValidationDetail[] $validationDetail
     * @return \ArrayType\ArrayOfValidationDetail
     */
    public function setValidationDetail(array $validationDetail = array())
    {
        foreach ($validationDetail as $arrayOfValidationDetailValidationDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfValidationDetailValidationDetailItem instanceof \StructType\ValidationDetail) {
                throw new \InvalidArgumentException(sprintf('The ValidationDetail property can only contain items of \StructType\ValidationDetail, "%s" given', is_object($arrayOfValidationDetailValidationDetailItem) ? get_class($arrayOfValidationDetailValidationDetailItem) : gettype($arrayOfValidationDetailValidationDetailItem)), __LINE__);
            }
        }
        if (is_null($validationDetail) || (is_array($validationDetail) && empty($validationDetail))) {
            unset($this->ValidationDetail);
        } else {
            $this->ValidationDetail = $validationDetail;
        }
        return $this;
    }
    /**
     * Add item to ValidationDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ValidationDetail $item
     * @return \ArrayType\ArrayOfValidationDetail
     */
    public function addToValidationDetail(\StructType\ValidationDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ValidationDetail) {
            throw new \InvalidArgumentException(sprintf('The ValidationDetail property can only contain items of \StructType\ValidationDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ValidationDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ValidationDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ValidationDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ValidationDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ValidationDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ValidationDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ValidationDetail
     */
    public function getAttributeName()
    {
        return 'ValidationDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfValidationDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
