<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetEstimateRequestContainer' => '\\StructType\\GetEstimateRequestContainer',
            'RequestContainer' => '\\StructType\\RequestContainer',
            'Shipment' => '\\StructType\\Shipment',
            'SenderInformation' => '\\StructType\\SenderInformation',
            'Address' => '\\StructType\\Address',
            'PhoneNumber' => '\\StructType\\PhoneNumber',
            'ReceiverInformation' => '\\StructType\\ReceiverInformation',
            'PaymentInformation' => '\\StructType\\PaymentInformation',
            'CreditCardInformation' => '\\StructType\\CreditCardInformation',
            'EstimateInformation' => '\\StructType\\EstimateInformation',
            'ArrayOfLineItem' => '\\ArrayType\\ArrayOfLineItem',
            'LineItem' => '\\StructType\\LineItem',
            'Weight' => '\\StructType\\Weight',
            'Dimension' => '\\StructType\\Dimension',
            'ArrayOfBoolValuePair' => '\\ArrayType\\ArrayOfBoolValuePair',
            'BoolValuePair' => '\\StructType\\BoolValuePair',
            'RequestContext' => '\\StructType\\RequestContext',
            'GetEstimateResponseContainer' => '\\StructType\\GetEstimateResponseContainer',
            'ResponseContainer' => '\\StructType\\ResponseContainer',
            'ResponseInformation' => '\\StructType\\ResponseInformation',
            'ArrayOfError' => '\\ArrayType\\ArrayOfError',
            'Error' => '\\StructType\\Error',
            'ArrayOfInformationalMessage' => '\\ArrayType\\ArrayOfInformationalMessage',
            'InformationalMessage' => '\\StructType\\InformationalMessage',
            'ArrayOfAccessorialItem' => '\\ArrayType\\ArrayOfAccessorialItem',
            'AccessorialItem' => '\\StructType\\AccessorialItem',
            'ArrayOfTax' => '\\ArrayType\\ArrayOfTax',
            'Tax' => '\\StructType\\Tax',
            'ResponseContext' => '\\StructType\\ResponseContext',
            'ValidationFault' => '\\StructType\\ValidationFault',
            'ArrayOfValidationDetail' => '\\ArrayType\\ArrayOfValidationDetail',
            'ValidationDetail' => '\\StructType\\ValidationDetail',
        );
    }
}
